/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.PerfSettingRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class PerfSetting extends TableImpl<PerfSettingRecord> {

    private static final long serialVersionUID = 794950470;

    /**
     * The reference instance of <code>PERF_SETTING</code>
     */
    public static final PerfSetting PERF_SETTING = new PerfSetting();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<PerfSettingRecord> getRecordType() {
        return PerfSettingRecord.class;
    }

    /**
     * The column <code>PERF_SETTING.SETTING_ID</code>.
     */
    public final TableField<PerfSettingRecord, Integer> SETTING_ID = createField("SETTING_ID", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>PERF_SETTING.SETTING_TYPE</code>.
     */
    public final TableField<PerfSettingRecord, String> SETTING_TYPE = createField("SETTING_TYPE", org.jooq.impl.SQLDataType.VARCHAR(255).nullable(false), this, "");

    /**
     * The column <code>PERF_SETTING.ORDINAL</code>.
     */
    public final TableField<PerfSettingRecord, Integer> ORDINAL = createField("ORDINAL", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>PERF_SETTING.SETTING_KEY</code>.
     */
    public final TableField<PerfSettingRecord, String> SETTING_KEY = createField("SETTING_KEY", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_SETTING.SETTING_LABEL</code>.
     */
    public final TableField<PerfSettingRecord, String> SETTING_LABEL = createField("SETTING_LABEL", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_SETTING.VALUE_TYPE</code>.
     */
    public final TableField<PerfSettingRecord, String> VALUE_TYPE = createField("VALUE_TYPE", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_SETTING.VALUE</code>.
     */
    public final TableField<PerfSettingRecord, String> VALUE = createField("VALUE", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_SETTING.CAPTION</code>.
     */
    public final TableField<PerfSettingRecord, String> CAPTION = createField("CAPTION", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_SETTING.RELATION</code>.
     */
    public final TableField<PerfSettingRecord, String> RELATION = createField("RELATION", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * Create a <code>PERF_SETTING</code> table reference
     */
    public PerfSetting() {
        this(DSL.name("PERF_SETTING"), null);
    }

    /**
     * Create an aliased <code>PERF_SETTING</code> table reference
     */
    public PerfSetting(String alias) {
        this(DSL.name(alias), PERF_SETTING);
    }

    /**
     * Create an aliased <code>PERF_SETTING</code> table reference
     */
    public PerfSetting(Name alias) {
        this(alias, PERF_SETTING);
    }

    private PerfSetting(Name alias, Table<PerfSettingRecord> aliased) {
        this(alias, aliased, null);
    }

    private PerfSetting(Name alias, Table<PerfSettingRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> PerfSetting(Table<O> child, ForeignKey<O, PerfSettingRecord> key) {
        super(child, key, PERF_SETTING);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.PERF_SETTING_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<PerfSettingRecord, Integer> getIdentity() {
        return Keys.IDENTITY_PERF_SETTING;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<PerfSettingRecord> getPrimaryKey() {
        return Keys.KEY_PERF_SETTING_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<PerfSettingRecord>> getKeys() {
        return Arrays.<UniqueKey<PerfSettingRecord>>asList(Keys.KEY_PERF_SETTING_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PerfSetting as(String alias) {
        return new PerfSetting(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PerfSetting as(Name alias) {
        return new PerfSetting(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public PerfSetting rename(String name) {
        return new PerfSetting(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public PerfSetting rename(Name name) {
        return new PerfSetting(name, null);
    }
}
